Index: abi/include/proc/uarg.h
===================================================================
--- abi/include/proc/uarg.h	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ abi/include/proc/uarg.h	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -40,5 +40,4 @@
 	void *uspace_entry;
 	void *uspace_stack;
-	size_t uspace_stack_size;
 	
 	void (* uspace_thread_function)();
Index: boot/Makefile.build
===================================================================
--- boot/Makefile.build	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ boot/Makefile.build	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -47,4 +47,8 @@
 	-Werror-implicit-function-declaration -wd170
 
+SUNCC_CFLAGS = -I$(INCLUDES) -xO$(OPTIMIZATION) \
+	-xnolib -xc99=all -features=extensions \
+	-erroff=E_ZERO_SIZED_STRUCT_UNION
+
 CLANG_CFLAGS = -I$(INCLUDES) -O$(OPTIMIZATION) -imacros $(CONFIG_HEADER) \
 	-fexec-charset=UTF-8 -fwide-exec-charset=UTF-32$(ENDIANESS) \
@@ -62,4 +66,5 @@
 	GCC_CFLAGS += -g
 	ICC_CFLAGS += -g
+	SUNCC_CFLAGS += -g
 	CLANG_CFLAGS += -g
 endif
@@ -78,4 +83,10 @@
 	CFLAGS = $(ICC_CFLAGS) $(EXTRA_CFLAGS)
 	DEPEND_DEFS = $(DEFS) $(CONFIG_DEFS)
+endif
+
+ifeq ($(COMPILER),suncc)
+	CFLAGS = $(SUNCC_CFLAGS) $(EXTRA_CFLAGS)
+	DEFS += $(CONFIG_DEFS)
+	DEPEND_DEFS = $(DEFS)
 endif
 
Index: boot/Makefile.common
===================================================================
--- boot/Makefile.common	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ boot/Makefile.common	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -201,9 +201,4 @@
 endif
 
-ifeq ($(CONFIG_MSIM),y)
-RD_APPS_NON_ESSENTIAL += \
-	$(USPACE_PATH)/app/msim/msim
-endif
-
 COMPONENTS = \
 	$(KERNEL_PATH)/kernel.bin \
Index: boot/Makefile.grub
===================================================================
--- boot/Makefile.grub	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ boot/Makefile.grub	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -60,5 +60,5 @@
 build_dist: clean
 	mkdir -p $(BOOT)
-	cp -r -L $(GRUB) $(BOOT)/grub
+	cp -r $(GRUB) $(BOOT)/grub
 ifeq ($(GRUB_ARCH),efi)
 	gunzip $(IMAGE)
Index: kernel/Makefile
===================================================================
--- kernel/Makefile	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/Makefile	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -103,4 +103,8 @@
 	-Werror-implicit-function-declaration -wd170
 
+SUNCC_CFLAGS = -I$(INCLUDES) -xO$(OPTIMIZATION) \
+	-xnolib -xc99=all -features=extensions \
+	-erroff=E_ZERO_SIZED_STRUCT_UNION
+
 CLANG_CFLAGS = -I$(INCLUDES) -O$(OPTIMIZATION) -imacros $(CONFIG_HEADER) \
 	-fexec-charset=UTF-8 -fwide-exec-charset=UTF-32$(ENDIANESS) \
@@ -122,4 +126,5 @@
 	GCC_CFLAGS += -g
 	ICC_CFLAGS += -g
+	SUNCC_CFLAGS += -g
 	CLANG_CFLAGS += -g
 endif
@@ -175,4 +180,11 @@
 	CFLAGS = $(ICC_CFLAGS)
 	DEPEND_DEFS = $(DEFS) $(CONFIG_DEFS)
+	INSTRUMENTATION =
+endif
+
+ifeq ($(COMPILER),suncc)
+	CFLAGS = $(SUNCC_CFLAGS)
+	DEFS += $(CONFIG_DEFS)
+	DEPEND_DEFS = $(DEFS)
 	INSTRUMENTATION =
 endif
Index: kernel/arch/abs32le/include/mm/page.h
===================================================================
--- kernel/arch/abs32le/include/mm/page.h	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/arch/abs32le/include/mm/page.h	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -105,12 +105,4 @@
 	set_pt_flags((pte_t *) (ptl3), (size_t) (i), (x))
 
-/* Set PTE present bit accessors for each level. */
-#define SET_PTL1_PRESENT_ARCH(ptl0, i)	\
-	set_pt_present((pte_t *) (ptl0), (size_t) (i))
-#define SET_PTL2_PRESENT_ARCH(ptl1, i)
-#define SET_PTL3_PRESENT_ARCH(ptl2, i)
-#define SET_FRAME_PRESENT_ARCH(ptl3, i) \
-	set_pt_present((pte_t *) (ptl3), (size_t) (i))
-
 /* Macros for querying the last level entries. */
 #define PTE_VALID_ARCH(p) \
@@ -181,13 +173,4 @@
 }
 
-NO_TRACE static inline void set_pt_present(pte_t *pt, size_t i)
-    WRITES(ARRAY_RANGE(pt, PTL0_ENTRIES_ARCH))
-    REQUIRES_ARRAY_MUTABLE(pt, PTL0_ENTRIES_ARCH)
-{
-	pte_t *p = &pt[i];
-
-	p->present = 1;
-}
-
 extern void page_arch_init(void);
 extern void page_fault(unsigned int, istate_t *);
Index: kernel/arch/amd64/Makefile.inc
===================================================================
--- kernel/arch/amd64/Makefile.inc	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/arch/amd64/Makefile.inc	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -55,4 +55,5 @@
 GCC_CFLAGS += $(CMN1)
 ICC_CFLAGS += $(CMN1)
+SUNCC_CFLAGS += -m64 -xmodel=kernel
 
 BITS = 64
@@ -66,4 +67,5 @@
 	GCC_CFLAGS += $(CMN2)
 	ICC_CFLAGS += $(CMN2)
+	SUNCC_CFLAGS += -xtarget=opteron
 endif
 
Index: kernel/arch/amd64/include/mm/page.h
===================================================================
--- kernel/arch/amd64/include/mm/page.h	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/arch/amd64/include/mm/page.h	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -119,14 +119,4 @@
 	set_pt_flags((pte_t *) (ptl3), (size_t) (i), (x))
 
-/* Set PTE present bit accessors for each level. */
-#define SET_PTL1_PRESENT_ARCH(ptl0, i) \
-	set_pt_present((pte_t *) (ptl0), (size_t) (i))
-#define SET_PTL2_PRESENT_ARCH(ptl1, i) \
-	set_pt_present((pte_t *) (ptl1), (size_t) (i))
-#define SET_PTL3_PRESENT_ARCH(ptl2, i) \
-	set_pt_present((pte_t *) (ptl2), (size_t) (i))
-#define SET_FRAME_PRESENT_ARCH(ptl3, i) \
-	set_pt_present((pte_t *) (ptl3), (size_t) (i))
-
 /* Macros for querying the last-level PTE entries. */
 #define PTE_VALID_ARCH(p) \
@@ -225,11 +215,4 @@
 }
 
-NO_TRACE static inline void set_pt_present(pte_t *pt, size_t i)
-{
-	pte_t *p = &pt[i];
-
-	p->present = 1;
-}
-
 extern void page_arch_init(void);
 extern void page_fault(unsigned int, istate_t *);
Index: kernel/arch/amd64/src/mm/page.c
===================================================================
--- kernel/arch/amd64/src/mm/page.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/arch/amd64/src/mm/page.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -57,5 +57,5 @@
 	uintptr_t cur;
 	unsigned int identity_flags =
-	    PAGE_GLOBAL | PAGE_CACHEABLE | PAGE_EXEC | PAGE_WRITE | PAGE_READ;
+	    PAGE_CACHEABLE | PAGE_EXEC | PAGE_GLOBAL | PAGE_WRITE;
 		
 	page_mapping_operations = &pt_mapping_operations;
Index: kernel/arch/amd64/src/userspace.c
===================================================================
--- kernel/arch/amd64/src/userspace.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/arch/amd64/src/userspace.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -55,5 +55,5 @@
 	asm volatile (
 		"pushq %[udata_des]\n"
-		"pushq %[stack_top]\n"
+		"pushq %[stack_size]\n"
 		"pushq %[ipl]\n"
 		"pushq %[utext_des]\n"
@@ -65,6 +65,5 @@
 		"iretq\n"
 		:: [udata_des] "i" (GDT_SELECTOR(UDATA_DES) | PL_USER),
-		   [stack_top] "r" ((uint8_t *) kernel_uarg->uspace_stack +
-		       kernel_uarg->uspace_stack_size),
+		   [stack_size] "r" (kernel_uarg->uspace_stack + STACK_SIZE),
 		   [ipl] "r" (ipl),
 		   [utext_des] "i" (GDT_SELECTOR(UTEXT_DES) | PL_USER),
@@ -75,5 +74,6 @@
 	
 	/* Unreachable */
-	while (1);
+	while (1)
+		;
 }
 
Index: kernel/arch/arm32/include/mm/page.h
===================================================================
--- kernel/arch/arm32/include/mm/page.h	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/arch/arm32/include/mm/page.h	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -40,5 +40,4 @@
 #include <mm/mm.h>
 #include <arch/exception.h>
-#include <arch/barrier.h>
 #include <trace.h>
 
@@ -110,12 +109,4 @@
 #define SET_FRAME_FLAGS_ARCH(ptl3, i, x) \
 	set_pt_level1_flags((pte_t *) (ptl3), (size_t) (i), (x))
-
-/* Set PTE present bit accessors for each level. */
-#define SET_PTL1_PRESENT_ARCH(ptl0, i) \
-	set_pt_level0_present((pte_t *) (ptl0), (size_t) (i))
-#define SET_PTL2_PRESENT_ARCH(ptl1, i)
-#define SET_PTL3_PRESENT_ARCH(ptl2, i)
-#define SET_FRAME_PRESENT_ARCH(ptl3, i) \
-	set_pt_level1_present((pte_t *) (ptl3), (size_t) (i))
 
 /* Macros for querying the last-level PTE entries. */
@@ -276,12 +267,4 @@
 }
 
-NO_TRACE static inline void set_pt_level0_present(pte_t *pt, size_t i)
-{
-	pte_level0_t *p = &pt[i].l0;
-
-	p->should_be_zero = 0;
-	write_barrier();
-	p->descriptor_type = PTE_DESCRIPTOR_COARSE_TABLE;
-}
 
 /** Sets flags of level 1 page table entry.
@@ -300,8 +283,11 @@
 	pte_level1_t *p = &pt[i].l1;
 	
-	if (flags & PAGE_NOT_PRESENT)
+	if (flags & PAGE_NOT_PRESENT) {
 		p->descriptor_type = PTE_DESCRIPTOR_NOT_PRESENT;
-	else
+		p->access_permission_3 = 1;
+	} else {
 		p->descriptor_type = PTE_DESCRIPTOR_SMALL_PAGE;
+		p->access_permission_3 = p->access_permission_0;
+	}
 	
 	p->cacheable = p->bufferable = (flags & PAGE_CACHEABLE) != 0;
@@ -326,13 +312,8 @@
 }
 
-NO_TRACE static inline void set_pt_level1_present(pte_t *pt, size_t i)
-{
-	pte_level1_t *p = &pt[i].l1;
-
-	p->descriptor_type = PTE_DESCRIPTOR_SMALL_PAGE;
-}
-	
+
 extern void page_arch_init(void);
 
+
 #endif /* __ASM__ */
 
Index: kernel/arch/arm32/src/userspace.c
===================================================================
--- kernel/arch/arm32/src/userspace.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/arch/arm32/src/userspace.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -92,6 +92,5 @@
 
 	/* set user stack */
-	ustate.sp = ((uint32_t) kernel_uarg->uspace_stack) +
-	    kernel_uarg->uspace_stack_size;
+	ustate.sp = ((uint32_t)kernel_uarg->uspace_stack) + STACK_SIZE;
 
 	/* set where uspace execution starts */
Index: kernel/arch/ia32/Makefile.inc
===================================================================
--- kernel/arch/ia32/Makefile.inc	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/arch/ia32/Makefile.inc	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -38,4 +38,5 @@
 GCC_CFLAGS += $(CMN1)
 ICC_CFLAGS += $(CMN1)
+SUNCC_CFLAGS += $(CMN1)
 CLANG_CFLAGS += $(CMN1)
 
@@ -49,20 +50,25 @@
 ifeq ($(PROCESSOR),athlon_xp)
 	CMN2 = -march=athlon-xp
+	SUNCC_CFLAGS += -xarch=ssea
 endif
 
 ifeq ($(PROCESSOR),athlon_mp)
 	CMN2 = -march=athlon-mp
+	SUNCC_CFLAGS += xarch=ssea
 endif
 
 ifeq ($(PROCESSOR),pentium3)
 	CMN2 = -march=pentium3
+	SUNCC_CFLAGS += -xarch=sse
 endif
 
 ifeq ($(PROCESSOR),pentium4)
 	CMN2 = -march=pentium4
+	SUNCC_CFLAGS += -xarch=sse2
 endif
 
 ifeq ($(PROCESSOR),core)
 	CMN2 = -march=prescott
+	SUNCC_CFLAGS += -xarch=sse3
 endif
 
Index: kernel/arch/ia32/include/mm/page.h
===================================================================
--- kernel/arch/ia32/include/mm/page.h	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/arch/ia32/include/mm/page.h	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -115,12 +115,4 @@
 	set_pt_flags((pte_t *) (ptl3), (size_t) (i), (x))
 
-/* Set PTE present bit accessors for each level. */
-#define SET_PTL1_PRESENT_ARCH(ptl0, i) \
-	set_pt_present((pte_t *) (ptl0), (size_t) (i))
-#define SET_PTL2_PRESENT_ARCH(ptl1, i)
-#define SET_PTL3_PRESENT_ARCH(ptl2, i)
-#define SET_FRAME_PRESENT_ARCH(ptl3, i) \
-	set_pt_present((pte_t *) (ptl3), (size_t) (i))
-
 /* Macros for querying the last level entries. */
 #define PTE_VALID_ARCH(p) \
@@ -202,11 +194,4 @@
 }
 
-NO_TRACE static inline void set_pt_present(pte_t *pt, size_t i)
-{
-	pte_t *p = &pt[i];
-
-	p->present = 1;
-}
-
 extern void page_arch_init(void);
 extern void page_fault(unsigned int, istate_t *);
Index: kernel/arch/ia32/src/mm/page.c
===================================================================
--- kernel/arch/ia32/src/mm/page.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/arch/ia32/src/mm/page.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -71,5 +71,8 @@
 	for (cur = 0; cur < min(config.identity_size, config.physmem_end);
 	    cur += FRAME_SIZE) {
-		flags = PAGE_GLOBAL | PAGE_CACHEABLE | PAGE_WRITE | PAGE_READ;
+		flags = PAGE_CACHEABLE | PAGE_WRITE;
+		if ((PA2KA(cur) >= config.base) &&
+		    (PA2KA(cur) < config.base + config.kernel_size))
+			flags |= PAGE_GLOBAL;
 		page_mapping_insert(AS_KERNEL, PA2KA(cur), cur, flags);
 	}
Index: kernel/arch/ia32/src/smp/apic.c
===================================================================
--- kernel/arch/ia32/src/smp/apic.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/arch/ia32/src/smp/apic.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -259,24 +259,4 @@
 }
 
-#define DELIVS_PENDING_SILENT_RETRIES	4	
-
-static void l_apic_wait_for_delivery(void)
-{
-	icr_t icr;
-	unsigned retries = 0;
-
-	do {
-		if (retries++ > DELIVS_PENDING_SILENT_RETRIES) {
-			retries = 0;
-#ifdef CONFIG_DEBUG
-			printf("IPI is pending.\n");
-#endif
-			delay(20);
-		}
-		icr.lo = l_apic[ICRlo];
-	} while (icr.delivs == DELIVS_PENDING);
-	
-}
-
 /** Send all CPUs excluding CPU IPI vector.
  *
@@ -299,6 +279,11 @@
 	
 	l_apic[ICRlo] = icr.lo;
-
-	l_apic_wait_for_delivery();
+	
+	icr.lo = l_apic[ICRlo];
+	if (icr.delivs == DELIVS_PENDING) {
+#ifdef CONFIG_DEBUG
+		printf("IPI is pending.\n");
+#endif
+	}
 	
 	return apic_poll_errors();
@@ -342,7 +327,11 @@
 		return 0;
 	
-	l_apic_wait_for_delivery();
-
 	icr.lo = l_apic[ICRlo];
+	if (icr.delivs == DELIVS_PENDING) {
+#ifdef CONFIG_DEBUG
+		printf("IPI is pending.\n");
+#endif
+	}
+	
 	icr.delmod = DELMOD_INIT;
 	icr.destmod = DESTMOD_PHYS;
Index: kernel/arch/ia32/src/userspace.c
===================================================================
--- kernel/arch/ia32/src/userspace.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/arch/ia32/src/userspace.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -63,5 +63,5 @@
 		
 		"pushl %[udata_des]\n"
-		"pushl %[stack_top]\n"
+		"pushl %[stack_size]\n"
 		"pushl %[ipl]\n"
 		"pushl %[utext_des]\n"
@@ -75,6 +75,5 @@
 		:
 		: [udata_des] "i" (GDT_SELECTOR(UDATA_DES) | PL_USER),
-		  [stack_top] "r" ((uint8_t *) kernel_uarg->uspace_stack +
-		      kernel_uarg->uspace_stack_size),
+		  [stack_size] "r" ((uint8_t *) kernel_uarg->uspace_stack + STACK_SIZE),
 		  [ipl] "r" (ipl),
 		  [utext_des] "i" (GDT_SELECTOR(UTEXT_DES) | PL_USER),
Index: kernel/arch/ia64/src/drivers/ski.c
===================================================================
--- kernel/arch/ia64/src/drivers/ski.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/arch/ia64/src/drivers/ski.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -150,6 +150,6 @@
 	
 	if (instance) {
-		instance->thread = thread_create(kskipoll, instance, TASK,
-		    THREAD_FLAG_UNCOUNTED, "kskipoll");
+		instance->thread = thread_create(kskipoll, instance, TASK, 0,
+		    "kskipoll", true);
 		
 		if (!instance->thread) {
Index: kernel/arch/ia64/src/ia64.c
===================================================================
--- kernel/arch/ia64/src/ia64.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/arch/ia64/src/ia64.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -232,16 +232,14 @@
 	 *
 	 * When calculating stack addresses, mind the stack split between the
-	 * memory stack and the RSE stack. Each occuppies
-	 * uspace_stack_size / 2 bytes.
+	 * memory stack and the RSE stack. Each occuppies STACK_SIZE / 2 bytes.
 	 */
 	switch_to_userspace((uintptr_t) kernel_uarg->uspace_entry,
-	    ((uintptr_t) kernel_uarg->uspace_stack) +
-	    kernel_uarg->uspace_stack_size / 2 -
+	    ((uintptr_t) kernel_uarg->uspace_stack) + STACK_SIZE / 2 -
 	    ALIGN_UP(STACK_ITEM_SIZE, STACK_ALIGNMENT),
-	    ((uintptr_t) kernel_uarg->uspace_stack) +
-	    kernel_uarg->uspace_stack_size / 2,
+	    ((uintptr_t) kernel_uarg->uspace_stack) + STACK_SIZE / 2,
 	    (uintptr_t) kernel_uarg->uspace_uarg, psr.value, rsc.value);
-	
-	while (1);
+
+	while (1)
+		;
 }
 
Index: kernel/arch/mips32/include/mm/page.h
===================================================================
--- kernel/arch/mips32/include/mm/page.h	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/arch/mips32/include/mm/page.h	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -128,12 +128,4 @@
 	set_pt_flags((pte_t *) (ptl3), (size_t) (i), (x))
 
-/* Set PTE present bit accessors for each level. */
-#define SET_PTL1_PRESENT_ARCH(ptl0, i) \
-	set_pt_present((pte_t *) (ptl0), (size_t) (i))
-#define SET_PTL2_PRESENT_ARCH(ptl1, i)
-#define SET_PTL3_PRESENT_ARCH(ptl2, i)
-#define SET_FRAME_PRESENT_ARCH(ptl3, i) \
-	set_pt_present((pte_t *) (ptl3), (size_t) (i))
-
 /* Last-level info macros. */
 #define PTE_VALID_ARCH(pte)			(*((uint32_t *) (pte)) != 0)
@@ -190,12 +182,4 @@
 }
 
-NO_TRACE static inline void set_pt_present(pte_t *pt, size_t i)
-{
-	pte_t *p = &pt[i];
-
-	p->p = 1;
-}
-	
-
 extern void page_arch_init(void);
 
Index: kernel/arch/mips32/src/mips32.c
===================================================================
--- kernel/arch/mips32/src/mips32.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/arch/mips32/src/mips32.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -211,6 +211,5 @@
 	    cp0_status_um_bit | cp0_status_ie_enabled_bit));
 	cp0_epc_write((uintptr_t) kernel_uarg->uspace_entry);
-	userspace_asm(((uintptr_t) kernel_uarg->uspace_stack +
-	    kernel_uarg->uspace_stack_size),
+	userspace_asm(((uintptr_t) kernel_uarg->uspace_stack + STACK_SIZE),
 	    (uintptr_t) kernel_uarg->uspace_uarg,
 	    (uintptr_t) kernel_uarg->uspace_entry);
Index: kernel/arch/mips64/src/mips64.c
===================================================================
--- kernel/arch/mips64/src/mips64.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/arch/mips64/src/mips64.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -188,6 +188,5 @@
 	    cp0_status_um_bit | cp0_status_ie_enabled_bit));
 	cp0_epc_write((uintptr_t) kernel_uarg->uspace_entry);
-	userspace_asm(((uintptr_t) kernel_uarg->uspace_stack +
-	    kernel_uarg->uspace_stack_size),
+	userspace_asm(((uintptr_t) kernel_uarg->uspace_stack + STACK_SIZE),
 	    (uintptr_t) kernel_uarg->uspace_uarg,
 	    (uintptr_t) kernel_uarg->uspace_entry);
Index: kernel/arch/ppc32/include/mm/page.h
===================================================================
--- kernel/arch/ppc32/include/mm/page.h	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/arch/ppc32/include/mm/page.h	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -129,14 +129,4 @@
 	set_pt_flags((pte_t *) (ptl3), (size_t) (i), (x))
 
-/* Set PTE present accessors for each level. */
-#define SET_PTL1_PRESENT_ARCH(ptl0, i) \
-	set_pt_present((pte_t *) (ptl0), (size_t) (i))
-
-#define SET_PTL2_PRESENT_ARCH(ptl1, i)
-#define SET_PTL3_PRESENT_ARCH(ptl2, i)
-
-#define SET_FRAME_PRESENT_ARCH(ptl3, i) \
-	set_pt_present((pte_t *) (ptl3), (size_t) (i))
-
 /* Macros for querying the last-level PTEs. */
 #define PTE_VALID_ARCH(pte)       (*((uint32_t *) (pte)) != 0)
@@ -185,11 +175,4 @@
 }
 
-NO_TRACE static inline void set_pt_present(pte_t *pt, size_t i)
-{
-	pte_t *entry = &pt[i];
-
-	entry->present = 1;
-}
-
 extern void page_arch_init(void);
 
Index: kernel/arch/ppc32/src/ppc32.c
===================================================================
--- kernel/arch/ppc32/src/ppc32.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/arch/ppc32/src/ppc32.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -269,6 +269,5 @@
 {
 	userspace_asm((uintptr_t) kernel_uarg->uspace_uarg,
-	    (uintptr_t) kernel_uarg->uspace_stack +
-	    kernel_uarg->uspace_stack_size - SP_DELTA,
+	    (uintptr_t) kernel_uarg->uspace_stack + STACK_SIZE - SP_DELTA,
 	    (uintptr_t) kernel_uarg->uspace_entry);
 	
Index: kernel/arch/sparc64/Makefile.inc
===================================================================
--- kernel/arch/sparc64/Makefile.inc	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/arch/sparc64/Makefile.inc	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -32,4 +32,5 @@
 
 GCC_CFLAGS += -m64 -mcpu=ultrasparc -mcmodel=medlow -mno-fpu
+SUNCC_CFLAGS += -m64 -xarch=sparc -xregs=appl,no%float
 
 LFLAGS += -no-check-sections
Index: kernel/arch/sparc64/src/drivers/niagara.c
===================================================================
--- kernel/arch/sparc64/src/drivers/niagara.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/arch/sparc64/src/drivers/niagara.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -184,6 +184,6 @@
 	
 	instance = malloc(sizeof(niagara_instance_t), FRAME_ATOMIC);
-	instance->thread = thread_create(kniagarapoll, NULL, TASK,
-	    THREAD_FLAG_UNCOUNTED, "kniagarapoll");
+	instance->thread = thread_create(kniagarapoll, NULL, TASK, 0,
+	    "kniagarapoll", true);
 	
 	if (!instance->thread) {
Index: kernel/arch/sparc64/src/proc/sun4u/scheduler.c
===================================================================
--- kernel/arch/sparc64/src/proc/sun4u/scheduler.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/arch/sparc64/src/proc/sun4u/scheduler.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -51,5 +51,5 @@
 void before_thread_runs_arch(void)
 {
-	if (THREAD->uspace) {
+	if ((THREAD->flags & THREAD_FLAG_USPACE)) {
 		/*
 		 * Write kernel stack address to %g6 of the alternate and
@@ -74,6 +74,6 @@
 void after_thread_ran_arch(void)
 {
-	if (THREAD->uspace) {
-		/* sample the state of the userspace window buffer */
+	if ((THREAD->flags & THREAD_FLAG_USPACE)) {
+		/* sample the state of the userspace window buffer */	
 		THREAD->arch.uspace_window_buffer = (uint8_t *) read_from_ag_g7();
 	}
Index: kernel/arch/sparc64/src/proc/sun4v/scheduler.c
===================================================================
--- kernel/arch/sparc64/src/proc/sun4v/scheduler.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/arch/sparc64/src/proc/sun4v/scheduler.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -54,5 +54,5 @@
 void before_thread_runs_arch(void)
 {
-	if (THREAD->uspace) {
+	if ((THREAD->flags & THREAD_FLAG_USPACE)) {
 		uint64_t sp = (uintptr_t) THREAD->kstack + STACK_SIZE -
 		    (STACK_BIAS + ALIGN_UP(STACK_ITEM_SIZE, STACK_ALIGNMENT));
@@ -66,6 +66,6 @@
 void after_thread_ran_arch(void)
 {
-	if (THREAD->uspace) {
-		/* sample the state of the userspace window buffer */
+	if ((THREAD->flags & THREAD_FLAG_USPACE)) {
+		/* sample the state of the userspace window buffer */	
 		THREAD->arch.uspace_window_buffer =
 		    (uint8_t *) asi_u64_read(ASI_SCRATCHPAD, SCRATCHPAD_WBUF);
Index: kernel/arch/sparc64/src/proc/thread.c
===================================================================
--- kernel/arch/sparc64/src/proc/thread.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/arch/sparc64/src/proc/thread.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -61,5 +61,5 @@
 void thread_create_arch(thread_t *t)
 {
-	if ((t->uspace) && (!t->arch.uspace_window_buffer))
+	if ((t->flags & THREAD_FLAG_USPACE) && (!t->arch.uspace_window_buffer))
 		{
 		/*
Index: kernel/arch/sparc64/src/smp/sun4u/ipi.c
===================================================================
--- kernel/arch/sparc64/src/smp/sun4u/ipi.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/arch/sparc64/src/smp/sun4u/ipi.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -124,5 +124,5 @@
 			(void) interrupts_disable();
 		}
-	} while (!done);
+	} while (done);
 	
 	preemption_enable();
Index: kernel/arch/sparc64/src/sun4u/sparc64.c
===================================================================
--- kernel/arch/sparc64/src/sun4u/sparc64.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/arch/sparc64/src/sun4u/sparc64.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -156,11 +156,11 @@
 	(void) interrupts_disable();
 	switch_to_userspace((uintptr_t) kernel_uarg->uspace_entry,
-	    ((uintptr_t) kernel_uarg->uspace_stack) +
-	    kernel_uarg->uspace_stack_size -
-	    (ALIGN_UP(STACK_ITEM_SIZE, STACK_ALIGNMENT) + STACK_BIAS),
+	    ((uintptr_t) kernel_uarg->uspace_stack) + STACK_SIZE
+	    - (ALIGN_UP(STACK_ITEM_SIZE, STACK_ALIGNMENT) + STACK_BIAS),
 	    (uintptr_t) kernel_uarg->uspace_uarg);
-	
-	/* Not reached */
-	while (1);
+
+	for (;;)
+		;
+	/* not reached */
 }
 
Index: kernel/arch/sparc64/src/sun4v/sparc64.c
===================================================================
--- kernel/arch/sparc64/src/sun4v/sparc64.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/arch/sparc64/src/sun4v/sparc64.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -154,11 +154,11 @@
 	(void) interrupts_disable();
 	switch_to_userspace((uintptr_t) kernel_uarg->uspace_entry,
-	    ((uintptr_t) kernel_uarg->uspace_stack) +
-	    kernel_uarg->uspace_stack_size -
-	    (ALIGN_UP(STACK_ITEM_SIZE, STACK_ALIGNMENT) + STACK_BIAS),
+	    ((uintptr_t) kernel_uarg->uspace_stack) + STACK_SIZE
+	    - (ALIGN_UP(STACK_ITEM_SIZE, STACK_ALIGNMENT) + STACK_BIAS),
 	    (uintptr_t) kernel_uarg->uspace_uarg);
-	
-	/* Not reached */
-	while (1);
+
+	for (;;)
+		;
+	/* not reached */
 }
 
Index: kernel/genarch/include/mm/page_pt.h
===================================================================
--- kernel/genarch/include/mm/page_pt.h	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/genarch/include/mm/page_pt.h	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -115,13 +115,4 @@
 
 /*
- * These macros are provided to set the present bit within the page tables.
- *
- */
-#define SET_PTL1_PRESENT(ptl0, i)   SET_PTL1_PRESENT_ARCH(ptl0, i)
-#define SET_PTL2_PRESENT(ptl1, i)   SET_PTL2_PRESENT_ARCH(ptl1, i)
-#define SET_PTL3_PRESENT(ptl2, i)   SET_PTL3_PRESENT_ARCH(ptl2, i)
-#define SET_FRAME_PRESENT(ptl3, i)  SET_FRAME_PRESENT_ARCH(ptl3, i)
-
-/*
  * Macros for querying the last-level PTEs.
  *
Index: kernel/genarch/src/kbrd/kbrd.c
===================================================================
--- kernel/genarch/src/kbrd/kbrd.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/genarch/src/kbrd/kbrd.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -158,6 +158,6 @@
 	    = malloc(sizeof(kbrd_instance_t), FRAME_ATOMIC);
 	if (instance) {
-		instance->thread = thread_create(kkbrd, (void *) instance,
-		    TASK, THREAD_FLAG_NONE, "kkbrd");
+		instance->thread
+			= thread_create(kkbrd, (void *) instance, TASK, 0, "kkbrd", false);
 		
 		if (!instance->thread) {
Index: kernel/genarch/src/mm/as_ht.c
===================================================================
--- kernel/genarch/src/mm/as_ht.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/genarch/src/mm/as_ht.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -78,6 +78,6 @@
 		hash_table_create(&page_ht, PAGE_HT_ENTRIES, 2, &ht_operations);
 		mutex_initialize(&page_ht_lock, MUTEX_PASSIVE);
-		pte_cache = slab_cache_create("pte_t", sizeof(pte_t), 0,
-		    NULL, NULL, SLAB_CACHE_MAGDEFERRED);
+		pte_cache = slab_cache_create("pte_cache", sizeof(pte_t), 0, NULL, NULL,
+		    SLAB_CACHE_MAGDEFERRED);
 	}
 	
Index: kernel/genarch/src/mm/page_ht.c
===================================================================
--- kernel/genarch/src/mm/page_ht.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/genarch/src/mm/page_ht.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -45,5 +45,4 @@
 #include <typedefs.h>
 #include <arch/asm.h>
-#include <arch/barrier.h>
 #include <synch/spinlock.h>
 #include <arch.h>
@@ -208,6 +207,4 @@
 		pte->page = ALIGN_DOWN(page, PAGE_SIZE);
 		pte->frame = ALIGN_DOWN(frame, FRAME_SIZE);
-
-		write_barrier();
 		
 		hash_table_insert(&page_ht, key, &pte->link);
Index: kernel/genarch/src/mm/page_pt.c
===================================================================
--- kernel/genarch/src/mm/page_pt.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/genarch/src/mm/page_pt.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -43,5 +43,4 @@
 #include <arch/mm/page.h>
 #include <arch/mm/as.h>
-#include <arch/barrier.h>
 #include <typedefs.h>
 #include <arch/asm.h>
@@ -87,8 +86,6 @@
 		SET_PTL1_ADDRESS(ptl0, PTL0_INDEX(page), KA2PA(newpt));
 		SET_PTL1_FLAGS(ptl0, PTL0_INDEX(page),
-		    PAGE_NOT_PRESENT | PAGE_USER | PAGE_EXEC | PAGE_CACHEABLE |
+		    PAGE_PRESENT | PAGE_USER | PAGE_EXEC | PAGE_CACHEABLE |
 		    PAGE_WRITE);
-		write_barrier();
-		SET_PTL1_PRESENT(ptl0, PTL0_INDEX(page));
 	}
 	
@@ -101,8 +98,6 @@
 		SET_PTL2_ADDRESS(ptl1, PTL1_INDEX(page), KA2PA(newpt));
 		SET_PTL2_FLAGS(ptl1, PTL1_INDEX(page),
-		    PAGE_NOT_PRESENT | PAGE_USER | PAGE_EXEC | PAGE_CACHEABLE |
+		    PAGE_PRESENT | PAGE_USER | PAGE_EXEC | PAGE_CACHEABLE |
 		    PAGE_WRITE);
-		write_barrier();
-		SET_PTL2_PRESENT(ptl1, PTL1_INDEX(page));	
 	}
 	
@@ -115,8 +110,6 @@
 		SET_PTL3_ADDRESS(ptl2, PTL2_INDEX(page), KA2PA(newpt));
 		SET_PTL3_FLAGS(ptl2, PTL2_INDEX(page),
-		    PAGE_NOT_PRESENT | PAGE_USER | PAGE_EXEC | PAGE_CACHEABLE |
+		    PAGE_PRESENT | PAGE_USER | PAGE_EXEC | PAGE_CACHEABLE |
 		    PAGE_WRITE);
-		write_barrier();
-		SET_PTL3_PRESENT(ptl2, PTL2_INDEX(page));
 	}
 	
@@ -124,7 +117,5 @@
 	
 	SET_FRAME_ADDRESS(ptl3, PTL3_INDEX(page), frame);
-	SET_FRAME_FLAGS(ptl3, PTL3_INDEX(page), flags | PAGE_NOT_PRESENT);
-	write_barrier();
-	SET_FRAME_PRESENT(ptl3, PTL3_INDEX(page));
+	SET_FRAME_FLAGS(ptl3, PTL3_INDEX(page), flags);
 }
 
@@ -288,22 +279,12 @@
 	if (GET_PTL1_FLAGS(ptl0, PTL0_INDEX(page)) & PAGE_NOT_PRESENT)
 		return NULL;
-
-	read_barrier();
 	
 	pte_t *ptl1 = (pte_t *) PA2KA(GET_PTL1_ADDRESS(ptl0, PTL0_INDEX(page)));
 	if (GET_PTL2_FLAGS(ptl1, PTL1_INDEX(page)) & PAGE_NOT_PRESENT)
 		return NULL;
-
-#if (PTL1_ENTRIES != 0)
-	read_barrier();
-#endif
 	
 	pte_t *ptl2 = (pte_t *) PA2KA(GET_PTL2_ADDRESS(ptl1, PTL1_INDEX(page)));
 	if (GET_PTL3_FLAGS(ptl2, PTL2_INDEX(page)) & PAGE_NOT_PRESENT)
 		return NULL;
-
-#if (PTL2_ENTRIES != 0)
-	read_barrier();
-#endif
 	
 	pte_t *ptl3 = (pte_t *) PA2KA(GET_PTL3_ADDRESS(ptl2, PTL2_INDEX(page)));
@@ -365,6 +346,6 @@
 		SET_PTL1_ADDRESS(ptl0, PTL0_INDEX(addr), KA2PA(l1));
 		SET_PTL1_FLAGS(ptl0, PTL0_INDEX(addr),
-		    PAGE_PRESENT | PAGE_USER | PAGE_CACHEABLE |
-		    PAGE_EXEC | PAGE_WRITE | PAGE_READ);
+		    PAGE_PRESENT | PAGE_USER | PAGE_EXEC | PAGE_CACHEABLE |
+		    PAGE_WRITE);
 	}
 }
Index: kernel/genarch/src/srln/srln.c
===================================================================
--- kernel/genarch/src/srln/srln.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/genarch/src/srln/srln.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -130,6 +130,6 @@
 	    = malloc(sizeof(srln_instance_t), FRAME_ATOMIC);
 	if (instance) {
-		instance->thread = thread_create(ksrln, (void *) instance,
-		    TASK, THREAD_FLAG_NONE, "ksrln");
+		instance->thread
+			= thread_create(ksrln, (void *) instance, TASK, 0, "ksrln", false);
 		
 		if (!instance->thread) {
Index: kernel/generic/include/ipc/ipcrsc.h
===================================================================
--- kernel/generic/include/ipc/ipcrsc.h	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/generic/include/ipc/ipcrsc.h	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -39,8 +39,8 @@
 #include <ipc/ipc.h>
 
-extern call_t *get_call(sysarg_t);
-extern int phone_alloc(task_t *);
-extern void phone_connect(int, answerbox_t *);
-extern void phone_dealloc(int);
+extern call_t * get_call(sysarg_t callid);
+extern int phone_alloc(task_t *t);
+extern void phone_connect(int phoneid, answerbox_t *box);
+extern void phone_dealloc(int phoneid);
 
 #endif
